%% RFA
load('RFA.mat')
% original file: 30kvSp3_C2_0-452_LaserTop_500mW-90-10BS_HFW1000um_5VppBlaner1_lock2-5mV_10ms_C70B42_WD9-1mm_GaAsB_VoltageSeries_0ns.mat

outxy = [25 25];
outwh = [30 30];

brightxy = [175 175];
brightwh = [30 30];

darkxy = [125 125];
darkwh = [30 30];

delayToPlot = 0;

outxywh = [outxy(1)-.5*outwh(1) outxy(2)-.5*outwh(2) outwh(1) outwh(2)];
brightxywh = [brightxy(1)-.5*brightwh(1) brightxy(2)-.5*brightwh(2) brightwh(1) brightwh(2)];
darkxywh = [darkxy(1)-.5*darkwh(1) darkxy(2)-.5*darkwh(2) darkwh(1) darkwh(2)];

micronToPx = max(xaxis)/size(SE,1);
uniqueV = unique(V);
% plot dark spot SE intensity at 0 delay as a function of RFA voltage
for i = 1:length(uniqueV)
    temp = SE(:,:,and(delay==delayToPlot,V==uniqueV(i)));
    SE_dark(i) = getMeanIntFromRegion(temp, darkxywh, micronToPx);
end
% plot bright spot SE intensity at 0 delay as a function of RFA voltage
for i = 1:length(uniqueV)   
    temp = SE(:,:,and(delay==delayToPlot,V==uniqueV(i)));
    SE_Bright(i) = getMeanIntFromRegion(temp, brightxywh, micronToPx);
end
% plot Reference SE intensity at 0 delay as a function of RFA voltage
for i = 1:length(uniqueV)   
    temp = SE(:,:,and(delay==delayToPlot,V==uniqueV(i)));
    SE_Ref(i) = getMeanIntFromRegion(temp, outxywh, micronToPx);
end
SEvsVoltageNorm_dark = (SE_dark-min(SE_dark))/(max(SE_dark)-min(SE_dark));
SEvsVoltageNorm_bright = (SE_Bright-min(SE_Bright))/(max(SE_Bright)-min(SE_Bright));
SEvsVoltageNorm_ref = (SE_Ref-min(SE_Ref))/(max(SE_Ref)-min(SE_Ref));


figure; 
% subplot(2,3,[1]);hold on;
subplot(1,5,3:5); hold on
S_curves = [SE_dark' SE_Bright' SE_Ref'];% SE_ROI'];
plot(uniqueV,SEvsVoltageNorm_dark,'o-','LineWidth',2,'markersize',2)
plot(uniqueV,SEvsVoltageNorm_bright,'o-','LineWidth',2,'markersize',2)
plot(uniqueV,SEvsVoltageNorm_ref,'o-','LineWidth',2,'markersize',2)
xlabel('Retarding voltage [V]')
ylabel('Normalised ETD signal [a.u.]')
set(gca,'colororderindex',1)
title('S-curves','fontsize',12)
set(gca,'position',[0.5 .2 .45 .7])
grid on
legend('Dark','Bright','Reference','location','southwest','fontsize',11)

% s=subplot(2,4,5);
s = subplot(1,5,1:2);
imagesc(xaxis,yaxis,lock(:,:,and(V==0, delay==0)));
colormap(s,'hot')
axis equal tight
title('GaAs (111)B','fontsize',12)
%     caxis([-3 3])
poss = get(gca,'position');
c = colorbar;
ylabel(c,'Laser induced SE intensity [V]','fontsize',10)
% set(gca,'position',poss)
axis off
caxis([-1.5 1.5])
rectangle('position',[25 225 50 15],'facecolor',[0 0 0],'linewidth',1)
% text(0,200,'50 \mum','fontsize',11,'fontweight','bold')
set(gca,'position',[0.0 0.2 .3 .7])
rectangle('position',outxywh,'linewidth',2,'edgecolor',[ 0.9290    0.6940    0.1250]) %outside
rectangle('position',brightxywh,'linewidth',2,'edgecolor',[ 0.8500    0.3250    0.0980]) % bright
rectangle('position',darkxywh,'linewidth',2,'edgecolor',[ 0    0.4470    0.7410]) %dark
% set(gcf,'position',[611   382   769   420])
set(gcf,'position',[157   678   845   307])

%% picoammeter
% load GBIP with ETD on
load('30kvSp3_C2_0-452_LaserTop_500mW-90-10BS_HFW1200um_5vppblank1_GBIP_1ns_250V.mat','-mat');
close(fig)

HFW = (xend-xstart)/2*1200;
xax = linspace(0, HFW, xres);
yax = linspace(0,HFW,yres);
filtsig  = .75;

figure;
subplot(1,2,1)
GBIPon = (abs(Ilaser)-abs(Idark))./(.5*(abs(Ilaser)+abs(Idark)))*100 ;
GBIPon = imgaussfilt( GBIPon , filtsig);
imagesc(xax(1:33),yax(1:33),GBIPon(7:40,17:end));
c = colorbar;
ylabel(c,'Current enhancement [%]','fontsize',10)
caxis([-.5 .5])
axis equal tight
title('I_{sample} SE detector field on','fontsize',12)
xlabel('X [\mum]')
ylabel('Y [\mum]')
axis off
rectangle('position',[15 135 50 10],'facecolor',[0 0 0],'linewidth',1)

set(gca,'position',[0.0 0.2 .3 .7])


% load GBIP with etd off
load('30kvSp3_C2_0-452_LaserTop_500mW-90-10BS_HFW1200um_5vppblank1_GBIP_1ns_ETDscintOff.mat');
close(fig)
subplot(1,2,2);
GBIPoff = (Ilaser-Idark)./(.5*(Ilaser+Idark))*100;
GBIPoff = imgaussfilt( GBIPoff , filtsig);
imagesc(xax(1:33),yax(1:33),GBIPoff(7:40,17:end));
c=colorbar;
ylabel(c,'Current enhancement [%]','fontsize',10)
caxis([-.5 .5])
axis equal tight
title('I_{sample} SE detector field off','fontsize',12)
xlabel('X [\mum]')
% ylabel('Y [\mum]')
colormap('hot')
axis off
rectangle('position',[15 135 50 10],'facecolor',[0 0 0],'linewidth',1)

set(gca,'position',[0.5 0.2 .3 .7])

set(gcf,'position',[157   678   845   307])


function meanval = getMeanIntFromRegion(img,xywh,micronToPx)
    meanval = mean(mean( img(round(xywh(1)/micronToPx):round((xywh(1)+xywh(3))/micronToPx),round(xywh(1)/micronToPx):round((xywh(2)+xywh(4))/micronToPx)) ));
end
